//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include "wclConnections.hpp"
#include "wclObex.hpp"
#include "wclIrDAClients.hpp"
#include "wclIrDADevices.hpp"
//---------------------------------------------------------------------------
class TfmMain : public TForm
{
__published:	// IDE-managed Components
        TLabel *laNewDirName;
        TLabel *laDesc;
        TButton *btDiscover;
        TButton *btConnect;
        TButton *btDisconnect;
        TListView *lvDevices;
        TButton *btOpenSession;
        TButton *btCloseSession;
        TButton *btClear;
        TListBox *lbLog;
        TButton *btSelectFile;
        TEdit *edFileName;
        TButton *btSendFile;
        TButton *btAbort;
        TProgressBar *ProgressBar;
        TButton *btMkDir;
        TButton *btDelete;
        TEdit *edNewDirName;
        TButton *btDir;
        TListView *lvFiles;
        TButton *btRoot;
        TOpenDialog *OpenDialog;
        TwclIrDAReceiver *wclIrDAReceiver;
        TwclIrDAClient *wclIrDAClient;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall btClearClick(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall btDiscoverClick(TObject *Sender);
        void __fastcall btDisconnectClick(TObject *Sender);
        void __fastcall btCloseSessionClick(TObject *Sender);
        void __fastcall btOpenSessionClick(TObject *Sender);
        void __fastcall wclIrDAClientDestroyProcessor(TObject *Sender,
          const TwclClientDataConnection *Connection);
        void __fastcall wclIrDAClientCreateProcessor(TObject *Sender,
          const TwclClientDataConnection *Connection);
        void __fastcall btConnectClick(TObject *Sender);
        void __fastcall btSelectFileClick(TObject *Sender);
        void __fastcall btAbortClick(TObject *Sender);
        void __fastcall btSendFileClick(TObject *Sender);
        void __fastcall btDirClick(TObject *Sender);
        void __fastcall lvFilesDblClick(TObject *Sender);
        void __fastcall btRootClick(TObject *Sender);
        void __fastcall btDeleteClick(TObject *Sender);
        void __fastcall btMkDirClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        TwclObexFtpClient* FFtp;

        void __fastcall FtpConnect(TObject* Sender, const int Error,
          const String Description);
        void __fastcall FtpDisconnect(TObject* Sender, const int Error,
		  const String Description);
        void __fastcall FtpDirComplete(TObject* Sender, const int Error,
		  const String Description, const TwclObexFileObjects Dirs);
		void __fastcall FtpChangeDirComplete(TObject* Sender, const int Error,
		  const String Description);
		void __fastcall FtpDeleteComplete(TObject* Sender, const int Error,
		  const String Description);
		void __fastcall FtpMkDirComplete(TObject* Sender, const int Error,
		  const String Description);
        void __fastcall FtpProgress(TObject* Sender, const unsigned Size,
		  const unsigned Position);
		#if __BORLANDC__ >= 0x0740
		  void __fastcall FtpPutComplete(TObject* Sender, const int Error,
			const String Description, TStream* const Stream);
		  void __fastcall FtpGetComplete(TObject* Sender, const int Error,
			const String Description, TStream* const Stream);
		#else
		  void __fastcall FtpPutComplete(TObject* Sender, const int Error,
			const String Description, const TStream* Stream);
		  void __fastcall FtpGetComplete(TObject* Sender, const int Error,
			const String Description, const TStream* Stream);
		#endif

        __fastcall TfmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmMain *fmMain;
//---------------------------------------------------------------------------
#endif
