//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include "wclIrDA.hpp"
#include "wclIrDADevices.hpp"
#include "wclPowerEvents.hpp"
//---------------------------------------------------------------------------
class TfmMain : public TForm
{
__published:	// IDE-managed Components
    TLabel *laClassName;
    TLabel *laAttributeName;
    TButton *btDiscover;
    TListView *lvDevices;
    TButton *ntSubscribe;
    TButton *btUnsubscribe;
    TListBox *lbEvents;
    TButton *btClear;
    TButton *btQuery;
    TComboBox *cbClassName;
    TComboBox *cbAttributeName;
    TButton *btStartLazyDiscovering;
    TButton *btStopLazyDiscovering;
    TwclIrDAReceiver *wclIrDAReceiver;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall btDiscoverClick(TObject *Sender);
    void __fastcall ntSubscribeClick(TObject *Sender);
    void __fastcall btUnsubscribeClick(TObject *Sender);
    void __fastcall btClearClick(TObject *Sender);
    void __fastcall cbClassNameChange(TObject *Sender);
    void __fastcall btQueryClick(TObject *Sender);
    void __fastcall btStartLazyDiscoveringClick(TObject *Sender);
    void __fastcall btStopLazyDiscoveringClick(TObject *Sender);
    void __fastcall wclIrDAReceiverChange(TObject *Sender);
    void __fastcall wclIrDAReceiverDevicesFound(TObject *Sender,
          const TwclIrDADevice &Device);
    void __fastcall FormDestroy(TObject *Sender);

private:	// User declarations
    TwclPowerEventsMonitor* FPowerMonitor;

    void __fastcall PowerStateChanged(TObject* Sender,
      const TwclPowerState State);

public:		// User declarations
    __fastcall TfmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmMain *fmMain;
//---------------------------------------------------------------------------
#endif
