//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "wclConnections.hpp"
#include "wclObex.hpp"
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include "wclIrDAClients.hpp"
#include "wclIrDADevices.hpp"
//---------------------------------------------------------------------------
class TfmMain : public TForm
{
__published:	// IDE-managed Components
        TButton *btDiscover;
        TListView *lvDevices;
        TListBox *lbLog;
        TButton *btClear;
        TButton *btConnect;
        TButton *btDisconnect;
        TButton *btOpenSession;
        TButton *btCloseSession;
        TButton *btSelectFile;
        TEdit *edFileName;
        TButton *btSendFile;
        TButton *btAbort;
        TProgressBar *ProgressBar;
        TButton *btGetvCard;
        TButton *btGetCaps;
        TOpenDialog *OpenDialog;
        TwclIrDAReceiver *wclIrDAReceiver;
        TwclIrDAClient *wclIrDAClient;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall btClearClick(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall btDiscoverClick(TObject *Sender);
        void __fastcall btDisconnectClick(TObject *Sender);
        void __fastcall btCloseSessionClick(TObject *Sender);
        void __fastcall btOpenSessionClick(TObject *Sender);
        void __fastcall btConnectClick(TObject *Sender);
        void __fastcall btSelectFileClick(TObject *Sender);
        void __fastcall btAbortClick(TObject *Sender);
        void __fastcall btSendFileClick(TObject *Sender);
        void __fastcall btGetvCardClick(TObject *Sender);
        void __fastcall btGetCapsClick(TObject *Sender);
        void __fastcall wclIrDAClientDisconnect(TObject *Sender,
          const int Reason);
        void __fastcall wclIrDAClientConnect(TObject *Sender,
          const int Error);
        void __fastcall wclIrDAClientCreateProcessor(TObject *Sender,
          const TwclClientDataConnection *Connection);
        void __fastcall wclIrDAClientDestroyProcessor(TObject *Sender,
          const TwclClientDataConnection *Connection);
private:	// User declarations
    TwclObexOppClient* FOpp;

    void __fastcall OppConnect(TObject* Sender, const int Error,
      const String Description);
    void __fastcall OppDisconnect(TObject* Sender, const int Error,
	  const String Description);
	#if __BORLANDC__ >= 0x0740
	  void __fastcall OppPutComplete(TObject* Sender, const int Error,
		const String Description, TStream* const Stream);
      void __fastcall OppGetComplete(TObject* Sender, const int Error,
		const String Description, TStream* const Stream);
	#else
	  void __fastcall OppPutComplete(TObject* Sender, const int Error,
		const String Description, const TStream* Stream);
      void __fastcall OppGetComplete(TObject* Sender, const int Error,
		const String Description, const TStream* Stream);
	#endif
	void __fastcall OppProgress(TObject* Sender, const unsigned Size,
	  const unsigned Position);
public:		// User declarations
        __fastcall TfmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmMain *fmMain;
//---------------------------------------------------------------------------
#endif
