//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "wclIrDAServers.hpp"
#include "wclErrors.hpp"
#include "wclObex.hpp"
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TfmMain : public TForm
{
__published:	// IDE-managed Components
        TButton *btListen;
        TButton *btClose;
        TButton *btClear;
        TListBox *lbLog;
        TwclIrDAServer *wclIrDAServer;
        TSaveDialog *SaveDialog;
        void __fastcall btClearClick(TObject *Sender);
        void __fastcall btListenClick(TObject *Sender);
        void __fastcall btCloseClick(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall wclIrDAServerListen(TObject *Sender);
        void __fastcall wclIrDAServerClosed(TObject *Sender,
          const int Reason);
        void __fastcall wclIrDAServerDisconnect(TObject *Sender,
          const TwclIrDAServerClientConnection *Client, const int Reason);
        void __fastcall wclIrDAServerDestroyProcessor(TObject *Sender,
          const TwclServerClientDataConnection *Connection);
        void __fastcall wclIrDAServerConnect(TObject *Sender,
          const TwclIrDAServerClientConnection *Client, const int Error);
        void __fastcall wclIrDAServerCreateProcessor(TObject *Sender,
          const TwclServerClientDataConnection *Connection);
private:	// User declarations
        String FFileName;
        
        void __fastcall Trace(String Msg);
        void __fastcall OppClientConnect(TObject* Sender, String Description);
        void __fastcall OppClientDisconnected(TObject* Sender, int Reason,
          String Description);
        void __fastcall OppClientPutBegin(TObject* Sender, String Name,
		  String Description, String Mime, unsigned Length, bool& Accept);
        void __fastcall OppClientPutProgress(TObject* Sender, unsigned Position,
          unsigned Length, bool& Continue);
		#if __BORLANDC__ >= 0x0740
		  void __fastcall OppClientPutCompleted(TObject* Sender, const int Error,
			TStream* const Stream, bool& Accept);
		#else
		  void __fastcall OppClientPutCompleted(TObject* Sender, const int Error,
			const TStream* Stream, bool& Accept);
		#endif
public:		// User declarations
        __fastcall TfmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmMain *fmMain;
//---------------------------------------------------------------------------
#endif
