﻿// CodeGear C++Builder
// Copyright (c) 1995, 2022 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'wclMessaging.pas' rev: 36.00 (Windows)

#ifndef WclmessagingHPP
#define WclmessagingHPP

#pragma delphiheader begin
#pragma option push
#if defined(__BORLANDC__) && !defined(__clang__)
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#endif
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <System.Classes.hpp>
#include <Winapi.Windows.hpp>
#include <wclWinAPI.hpp>
#include <wclErrors.hpp>

//-- user supplied -----------------------------------------------------------

namespace Wclmessaging
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TwclMessage;
class DELPHICLASS TwclSystemCategoryMessage;
class DELPHICLASS TwclHardwareChangeMessage;
class DELPHICLASS TwclPowerStateChangeMessage;
class DELPHICLASS TwclThreadSignalMessage;
class DELPHICLASS TwclThreadSynchronizeMessage;
class DELPHICLASS TwclWiFiCategoryMessage;
class DELPHICLASS TwclBluetoothCategoryMessage;
class DELPHICLASS TwclIrDACategoryMessage;
class DELPHICLASS TwclSerialCategoryMessage;
class DELPHICLASS TwclUsbCategoryMessage;
class DELPHICLASS TwclWiiCategoryMessage;
class DELPHICLASS TwclKinectCategoryMessage;
class DELPHICLASS TwclConnectionCategoryMessage;
class DELPHICLASS TwclAudioCategoryMessage;
class DELPHICLASS TwclUserDefinedCategoryMessage;
class DELPHICLASS TwclMessageReceiver;
class DELPHICLASS TwclMessageBroadcaster;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TwclMessageSynchronizationKind : unsigned int { skMessages, skThread, skApc };

class PASCALIMPLEMENTATION TwclMessage : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::Byte FId;
	System::Byte FCategory;
	int FRefCounter;
	
public:
	__fastcall TwclMessage(const System::Byte Id, const System::Byte Category);
	void __fastcall AddRef();
	void __fastcall Release();
	__property System::Byte Category = {read=FCategory, nodefault};
	__property System::Byte Id = {read=FId, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclMessage() { }
	
};


class PASCALIMPLEMENTATION TwclSystemCategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclSystemCategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclSystemCategoryMessage() { }
	
};


class PASCALIMPLEMENTATION TwclHardwareChangeMessage : public TwclSystemCategoryMessage
{
	typedef TwclSystemCategoryMessage inherited;
	
private:
	GUID FInterfaceClass;
	GUID FDeviceClass;
	System::UnicodeString FInstance;
	bool FInserted;
	
public:
	__fastcall TwclHardwareChangeMessage(const GUID &InterfaceClass, const GUID &DeviceClass, const System::UnicodeString Instance, const bool Inserted);
	__property GUID InterfaceClass = {read=FInterfaceClass};
	__property GUID DeviceClass = {read=FDeviceClass};
	__property System::UnicodeString Instance = {read=FInstance};
	__property bool Inserted = {read=FInserted, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclHardwareChangeMessage() { }
	
};


class PASCALIMPLEMENTATION TwclPowerStateChangeMessage : public TwclSystemCategoryMessage
{
	typedef TwclSystemCategoryMessage inherited;
	
private:
	unsigned FState;
	
public:
	__fastcall TwclPowerStateChangeMessage(const unsigned State);
	__property unsigned State = {read=FState, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclPowerStateChangeMessage() { }
	
};


class PASCALIMPLEMENTATION TwclThreadSignalMessage : public TwclSystemCategoryMessage
{
	typedef TwclSystemCategoryMessage inherited;
	
private:
	System::Byte FSignal;
	
public:
	__fastcall TwclThreadSignalMessage(const System::Byte Signal);
	__property System::Byte Signal = {read=FSignal, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclThreadSignalMessage() { }
	
};


class PASCALIMPLEMENTATION TwclThreadSynchronizeMessage : public TwclSystemCategoryMessage
{
	typedef TwclSystemCategoryMessage inherited;
	
private:
	Winapi::Windows::THandle FEvent;
	void *FParam;
	
public:
	__fastcall TwclThreadSynchronizeMessage(const Winapi::Windows::THandle Event, const void * Param);
	__fastcall virtual ~TwclThreadSynchronizeMessage();
	__property void * Param = {read=FParam};
};


class PASCALIMPLEMENTATION TwclWiFiCategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclWiFiCategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclWiFiCategoryMessage() { }
	
};


class PASCALIMPLEMENTATION TwclBluetoothCategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclBluetoothCategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclBluetoothCategoryMessage() { }
	
};


class PASCALIMPLEMENTATION TwclIrDACategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclIrDACategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclIrDACategoryMessage() { }
	
};


class PASCALIMPLEMENTATION TwclSerialCategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclSerialCategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclSerialCategoryMessage() { }
	
};


class PASCALIMPLEMENTATION TwclUsbCategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclUsbCategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclUsbCategoryMessage() { }
	
};


class PASCALIMPLEMENTATION TwclWiiCategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclWiiCategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclWiiCategoryMessage() { }
	
};


class PASCALIMPLEMENTATION TwclKinectCategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclKinectCategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclKinectCategoryMessage() { }
	
};


class PASCALIMPLEMENTATION TwclConnectionCategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclConnectionCategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclConnectionCategoryMessage() { }
	
};


class PASCALIMPLEMENTATION TwclAudioCategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclAudioCategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclAudioCategoryMessage() { }
	
};


class PASCALIMPLEMENTATION TwclUserDefinedCategoryMessage : public TwclMessage
{
	typedef TwclMessage inherited;
	
public:
	__fastcall TwclUserDefinedCategoryMessage(const System::Byte Id);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TwclUserDefinedCategoryMessage() { }
	
};


typedef void __fastcall (__closure *TwclMessageEvent)(TwclMessage* const Message);

class PASCALIMPLEMENTATION TwclMessageReceiver : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TwclMessageSynchronizationKind FKind;
	System::Classes::TList* FMessages;
	_RTL_CRITICAL_SECTION FMessagesCS;
	Winapi::Windows::THandle FThreadHandle;
	unsigned FThreadId;
	unsigned FWndThreadId;
	Winapi::Windows::THandle FWndThread;
	int FWndThreadResult;
	Winapi::Windows::THandle FWndThreadEvent;
	bool FListening;
	TwclMessageEvent FOnMessage;
	unsigned FMsg;
	HWND FWnd;
	bool __fastcall WndProc(unsigned uMsg, unsigned __int64 wParam, __int64 lParam);
	void __fastcall WndThread();
	int __fastcall CreateSyncObj();
	int __fastcall CreateSyncWnd();
	int __fastcall DestroySyncObj();
	int __fastcall DestroySyncWnd();
	int __fastcall Synchronize();
	void __fastcall ProcessMessages();
	
protected:
	virtual void __fastcall DoMessage(TwclMessage* const Message);
	
public:
	__fastcall virtual TwclMessageReceiver();
	__fastcall virtual ~TwclMessageReceiver();
	int __fastcall Close();
	int __fastcall Open();
	int __fastcall Post(TwclMessage* const Message, const bool Sync = false);
	__property bool Listening = {read=FListening, nodefault};
	__property TwclMessageEvent OnMessage = {read=FOnMessage, write=FOnMessage};
};


class PASCALIMPLEMENTATION TwclMessageBroadcaster : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::Classes::TList* FReceivers;
	_RTL_CRITICAL_SECTION FReceiversCS;
	unsigned __int64 FPowerDll;
	Winapi::Windows::THandle FPowerReg;
	bool FCfgMgrLoaded;
	void *FDevNotify;
	Winapi::Windows::THandle FThread;
	Winapi::Windows::THandle FThreadEvent;
	HWND FWnd;
	int FError;
	void __fastcall RegisterPowerChanges();
	void __fastcall UnregisterPowerChanges();
	bool __fastcall GetDevClassSetupApi(const GUID &IntfClass, const System::UnicodeString DevName, /* out */ GUID &DevClass);
	bool __fastcall GetDevClassCfgMgrApi(const System::UnicodeString DevName, /* out */ GUID &DevClass);
	void __fastcall ThreadProc();
	void __fastcall ProcessWmDestroy();
	void __fastcall ProcessWmDeviceChange(const unsigned __int64 wParam, const __int64 lParam);
	void __fastcall ProcessWmPowerBroadcast(const unsigned __int64 wParam);
	bool __fastcall WndProc(unsigned uMsg, unsigned __int64 wParam, __int64 lParam);
	int __fastcall InternalSubscribe(TwclMessageReceiver* const Receiver);
	int __fastcall InternalUnsubscribe(TwclMessageReceiver* const Receiver);
	__classmethod int __fastcall CreateBroadcaster();
	__classmethod void __fastcall DeleteBroadcaster();
	__classmethod int __fastcall Subscribe(TwclMessageReceiver* const Receiver);
	__classmethod int __fastcall Unsubscribe(TwclMessageReceiver* const Receiver);
	void __fastcall InternalBroadcast(TwclMessage* const Message);
	void __fastcall InternalProcessApcMessages();
	void __fastcall InternalProcessThreadMessages();
	void __fastcall InternalProcessWindowsMessages();
	void __fastcall InternalProcessMessages();
	int __fastcall InternalWaitWindowsMessages(const unsigned Count, const Winapi::Windows::PWOHandleArray Events, const unsigned Timeout, /* out */ unsigned &Index);
	int __fastcall InternalWaitThread(const unsigned Count, const Winapi::Windows::PWOHandleArray Events, const unsigned Timeout, /* out */ unsigned &Index);
	int __fastcall InternalWaitApcMessages(const unsigned Count, const Winapi::Windows::PWOHandleArray Events, const unsigned Timeout, /* out */ unsigned &Index);
	int __fastcall InternalWait(const unsigned Count, const Winapi::Windows::PWOHandleArray Events, const unsigned Timeout, /* out */ unsigned &Index);
	
public:
	__fastcall virtual TwclMessageBroadcaster();
	__fastcall virtual ~TwclMessageBroadcaster();
	__classmethod int __fastcall Broadcast(TwclMessage* const Message);
	__classmethod int __fastcall ProcessMessages();
	__classmethod int __fastcall Wait(const unsigned Count, const Winapi::Windows::PWOHandleArray Events, const unsigned Timeout, /* out */ unsigned &Index)/* overload */;
	__classmethod int __fastcall Wait(const unsigned Count, const Winapi::Windows::PWOHandleArray Events, /* out */ unsigned &Index)/* overload */;
	__classmethod int __fastcall Wait(const Winapi::Windows::THandle Event, const unsigned Timeout)/* overload */;
	__classmethod int __fastcall Wait(const Winapi::Windows::THandle Event)/* overload */;
	__classmethod TwclMessageSynchronizationKind __fastcall GetSyncMethod();
	__classmethod int __fastcall SetSyncMethod(const TwclMessageSynchronizationKind Kind);
};


//-- var, const, procedure ---------------------------------------------------
static const System::Int8 WCL_MSG_CATEGORY_SYSTEM = System::Int8(0x1);
static const System::Int8 WCL_MSG_CATEGORY_WIFI = System::Int8(0x2);
static const System::Int8 WCL_MSG_CATEGORY_BLUETOOTH = System::Int8(0x3);
static const System::Int8 WCL_MSG_CATEGORY_IRDA = System::Int8(0x4);
static const System::Int8 WCL_MSG_CATEGORY_SERIAL = System::Int8(0x5);
static const System::Int8 WCL_MSG_CATEGORY_USB = System::Int8(0x6);
static const System::Int8 WCL_MSG_CATEGORY_WII = System::Int8(0x7);
static const System::Int8 WCL_MSG_CATEGORY_KINECT = System::Int8(0x8);
static const System::Int8 WCL_MSG_CATEGORY_CONNECTION = System::Int8(0x9);
static const System::Int8 WCL_MSG_CATEGORY_AUDIO = System::Int8(0xa);
static const System::Byte WCL_MSG_CATEGORY_USER = System::Byte(0xc8);
static const System::Int8 WCL_MSG_ID_SYS_HARDWARE_CHANGED = System::Int8(0x1);
static const System::Int8 WCL_MSG_ID_SYS_POWER_STATE_CHANGED = System::Int8(0x2);
static const System::Int8 WCL_MSG_ID_SYS_THREAD_SIGNAL = System::Int8(0x3);
static const System::Int8 WCL_MSG_ID_SYS_THREAD_SYNCHRONIZE = System::Int8(0x4);
}	/* namespace Wclmessaging */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_WCLMESSAGING)
using namespace Wclmessaging;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// WclmessagingHPP
