// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Wclobex.pas' rev: 10.00

#ifndef WclobexHPP
#define WclobexHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Wclconnections.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Wclerrors.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Wclobex
{
//-- type declarations -------------------------------------------------------
typedef DynamicArray<Byte >  TwclObexAppParams;

typedef void __fastcall (__closure *TwclObexOperationResultEvent)(System::TObject* Sender, const int Error, const AnsiString Description);

typedef void __fastcall (__closure *TwclObexOperationProgressEvent)(System::TObject* Sender, const unsigned Length, const unsigned Position);

class DELPHICLASS TwclCustomObexClient;
class PASCALIMPLEMENTATION TwclCustomObexClient : public Wclconnections::TwclCustomClientDataProcessor 
{
	typedef Wclconnections::TwclCustomClientDataProcessor inherited;
	
private:
	bool FAbort;
	AnsiString FAbortDescription;
	char *FBuffer;
	unsigned FBufferSize;
	bool FConnected;
	unsigned FConnectionId;
	AnsiString FDescription;
	Word FMaxSize;
	Byte FPrevRequest;
	Byte FRequest;
	unsigned FSize;
	Classes::TStream* FStream;
	TwclObexOperationResultEvent FOnConnect;
	TwclObexOperationResultEvent FOnDisconnect;
	TwclObexOperationProgressEvent FOnProgress;
	void __fastcall InitParameters(void);
	int __fastcall ExecuteAbort(void);
	void __fastcall ProcessAbort(const char * Buffer);
	void __fastcall ProcessConnect(const char * Buffer);
	void __fastcall ProcessDisconnect(const char * Buffer);
	void __fastcall ProcessGet(const char * Buffer);
	void __fastcall ProcessPut(const char * Buffer);
	void __fastcall ProcessSetPath(const char * Buffer);
	void __fastcall ProcessResponse(const char * Buffer);
	
protected:
	int __fastcall Connect(const GUID &Target, const GUID &Who, const AnsiString Description, const Word PacketSize);
	int __fastcall Get(const AnsiString Name, const AnsiString Mime, const Classes::TStream* Stream);
	int __fastcall Put(const AnsiString Name, const AnsiString Mime, const AnsiString Description, const Classes::TStream* Stream, const TwclObexAppParams AppParams);
	int __fastcall SetPath(const AnsiString Dir, const bool Create);
	virtual void __fastcall DoConnect(const int Error, const AnsiString Description);
	virtual void __fastcall DoDisconnect(const int Error, const AnsiString Description);
	virtual void __fastcall DoGetComplete(const int Error, const AnsiString Description, const Classes::TStream* Stream);
	virtual void __fastcall DoProgress(const unsigned Length, const unsigned Position);
	virtual void __fastcall DoPutComplete(const int Error, const AnsiString Description, const Classes::TStream* Stream);
	virtual void __fastcall DoSetPathComplete(const int Error, const AnsiString Description);
	
public:
	__fastcall virtual TwclCustomObexClient(const Wclconnections::TwclClientDataConnection* Connection);
	__fastcall virtual ~TwclCustomObexClient(void);
	virtual void __fastcall ProcessData(const void * Data, const unsigned Size);
	int __fastcall Abort(const AnsiString Description);
	int __fastcall Disconnect(const AnsiString Description);
	__property bool Connected = {read=FConnected, nodefault};
	__property TwclObexOperationResultEvent OnConnect = {read=FOnConnect, write=FOnConnect};
	__property TwclObexOperationResultEvent OnDisconnect = {read=FOnDisconnect, write=FOnDisconnect};
	__property TwclObexOperationProgressEvent OnProgress = {read=FOnProgress, write=FOnProgress};
};


typedef void __fastcall (__closure *TwclObexObjectOperationResultEvent)(System::TObject* Sender, const int Error, const AnsiString Description, const Classes::TStream* Stream);

class DELPHICLASS TwclObexFileClient;
class PASCALIMPLEMENTATION TwclObexFileClient : public TwclCustomObexClient 
{
	typedef TwclCustomObexClient inherited;
	
private:
	TwclObexObjectOperationResultEvent FOnGetComplete;
	TwclObexObjectOperationResultEvent FOnPutComplete;
	
protected:
	virtual void __fastcall DoGetComplete(const int Error, const AnsiString Description, const Classes::TStream* Stream);
	virtual void __fastcall DoPutComplete(const int Error, const AnsiString Description, const Classes::TStream* Stream);
	
public:
	__fastcall virtual TwclObexFileClient(const Wclconnections::TwclClientDataConnection* Connection);
	HIDESBASE int __fastcall Put(const AnsiString Name, const AnsiString Description, const Classes::TStream* Stream)/* overload */;
	__property TwclObexObjectOperationResultEvent OnGetComplete = {read=FOnGetComplete, write=FOnGetComplete};
	__property TwclObexObjectOperationResultEvent OnPutComplete = {read=FOnPutComplete, write=FOnPutComplete};
public:
	#pragma option push -w-inl
	/* TwclCustomObexClient.Destroy */ inline __fastcall virtual ~TwclObexFileClient(void) { }
	#pragma option pop
	
};


class DELPHICLASS TwclObexOppClient;
class PASCALIMPLEMENTATION TwclObexOppClient : public TwclObexFileClient 
{
	typedef TwclObexFileClient inherited;
	
public:
	HIDESBASE int __fastcall Connect(const Word PacketSize = (Word)(0xffff))/* overload */;
	HIDESBASE int __fastcall Get(const AnsiString aType, const Classes::TStream* Stream)/* overload */;
public:
	#pragma option push -w-inl
	/* TwclObexFileClient.Create */ inline __fastcall virtual TwclObexOppClient(const Wclconnections::TwclClientDataConnection* Connection) : TwclObexFileClient(Connection) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TwclCustomObexClient.Destroy */ inline __fastcall virtual ~TwclObexOppClient(void) { }
	#pragma option pop
	
};


#pragma option push -b
enum TwclObexFilePermission { opRead, opWrite, opDelete };
#pragma option pop

typedef Set<TwclObexFilePermission, opRead, opDelete>  TwclObexFilePermissions;

struct TwclObexFileObject
{
	
public:
	bool IsDirectory;
	AnsiString Name;
	AnsiString Description;
	unsigned Size;
	TwclObexFilePermissions Permissions;
	System::TDateTime Modified;
	System::TDateTime Created;
	System::TDateTime Accessed;
} ;

typedef DynamicArray<TwclObexFileObject >  TwclObexFileObjects;

typedef void __fastcall (__closure *TwclObexFtpDirCompleteEvent)(System::TObject* Sender, const int Error, const AnsiString Description, const TwclObexFileObjects Dirs);

class DELPHICLASS TwclObexFtpClient;
class PASCALIMPLEMENTATION TwclObexFtpClient : public TwclObexFileClient 
{
	typedef TwclObexFileClient inherited;
	
private:
	Byte FOpCode;
	TwclObexOperationResultEvent FOnChangeDirComplete;
	TwclObexOperationResultEvent FOnDeleteComplete;
	TwclObexFtpDirCompleteEvent FOnDirComplete;
	TwclObexOperationResultEvent FOnMakeDirComplete;
	System::TDateTime __fastcall ConvertObexDateTime(const WideString DateStr);
	void __fastcall ParseDirs(const Classes::TStream* Stream, const AnsiString ResDesc);
	
protected:
	virtual void __fastcall DoGetComplete(const int Error, const AnsiString Description, const Classes::TStream* Stream);
	virtual void __fastcall DoPutComplete(const int Error, const AnsiString Description, const Classes::TStream* Stream);
	virtual void __fastcall DoSetPathComplete(const int Error, const AnsiString Description);
	
public:
	__fastcall virtual TwclObexFtpClient(const Wclconnections::TwclClientDataConnection* Connection);
	HIDESBASE int __fastcall Connect(const Word PacketSize = (Word)(0xffff))/* overload */;
	int __fastcall ChangeDir(const AnsiString Name);
	int __fastcall Delete(const AnsiString Name);
	int __fastcall Dir(void);
	HIDESBASE int __fastcall Get(const AnsiString Name, const Classes::TStream* Stream);
	int __fastcall MkDir(const AnsiString Name);
	HIDESBASE int __fastcall Put(const AnsiString Name, const AnsiString Description, const Classes::TStream* Stream);
	__property TwclObexOperationResultEvent OnChangeDirComplete = {read=FOnChangeDirComplete, write=FOnChangeDirComplete};
	__property TwclObexOperationResultEvent OnDeleteComplete = {read=FOnDeleteComplete, write=FOnDeleteComplete};
	__property TwclObexFtpDirCompleteEvent OnDirComplete = {read=FOnDirComplete, write=FOnDirComplete};
	__property TwclObexOperationResultEvent OnMakeDirComplete = {read=FOnMakeDirComplete, write=FOnMakeDirComplete};
public:
	#pragma option push -w-inl
	/* TwclCustomObexClient.Destroy */ inline __fastcall virtual ~TwclObexFtpClient(void) { }
	#pragma option pop
	
};


#pragma option push -b
enum TwclObexServerOperationResult { orSuccess, orForbidden, orObjectNotFound, orUnsupportedMedia, orAccessDenied, orUnexpected };
#pragma option pop

typedef void __fastcall (__closure *TwclObexServerClientDisconnectedEvent)(System::TObject* Sender, const int Reason, const AnsiString Description);

typedef void __fastcall (__closure *TwclObexServerClientGetCompletedEvent)(System::TObject* Sender, const int Error, const Classes::TStream* Stream);

typedef void __fastcall (__closure *TwclObexServerClientOperationProgressEvent)(System::TObject* Sender, const unsigned Position, const unsigned Length, /* out */ bool &Continue);

typedef void __fastcall (__closure *TwclObexServerClientPutBeginEvent)(System::TObject* Sender, const AnsiString Name, const AnsiString Description, const AnsiString Mime, const unsigned Length, /* out */ bool &Accept);

typedef void __fastcall (__closure *TwclObexServerClientPutCompletedEvent)(System::TObject* Sender, const int Error, const Classes::TStream* Stream, /* out */ bool &Accept);

class DELPHICLASS TwclCustomObexServer;
class PASCALIMPLEMENTATION TwclCustomObexServer : public Wclconnections::TwclCustomServerClientDataProcessor 
{
	typedef Wclconnections::TwclCustomServerClientDataProcessor inherited;
	
private:
	char *FBuffer;
	unsigned FBufferSize;
	bool FConnecting;
	Word FMaxSize;
	Byte FOperation;
	Classes::TStream* FStream;
	bool FFinalBitSet;
	AnsiString FMime;
	AnsiString FName;
	unsigned FConnectionId;
	AnsiString FDescription;
	#pragma pack(push,1)
	GUID FTarget;
	#pragma pack(pop)
	#pragma pack(push,1)
	GUID FWho;
	#pragma pack(pop)
	TwclObexServerClientDisconnectedEvent FOnDisconnected;
	TwclObexServerClientGetCompletedEvent FOnGetCompleted;
	TwclObexOperationProgressEvent FOnProgress;
	TwclObexServerClientPutBeginEvent FOnPutBegin;
	TwclObexServerClientPutCompletedEvent FOnPutCompleted;
	TwclObexServerClientOperationProgressEvent FOnPutProgress;
	bool __fastcall GetConnected(void);
	int __fastcall GenerateConnectionId(void);
	void __fastcall ReleaseStream(void);
	void __fastcall ResetGetFields(void);
	void __fastcall ResetGetOperation(void);
	void __fastcall ProcessAbort(const char * Buffer);
	void __fastcall ProcessConnect(const char * Buffer);
	void __fastcall ProcessDisconnect(const char * Buffer);
	void __fastcall ProcessGet(const char * Buffer);
	void __fastcall ProcessPut(const char * Buffer);
	void __fastcall ProcessRequest(const char * Buffer);
	void __fastcall SendObjectSize(void);
	void __fastcall SendObjectBody(void);
	void __fastcall SendResponse(const Byte Id, const unsigned ConId, const AnsiString Description);
	void __fastcall SendRejectResponse(const AnsiString Description);
	void __fastcall CallDoGetCompleted(const int Error);
	void __fastcall CallDoGetRequest(/* out */ TwclObexServerOperationResult &Result, /* out */ Classes::TStream* &Stream);
	void __fastcall CallDoPutCompleted(const int Error, /* out */ bool &Accept);
	
protected:
	virtual void __fastcall DoConnect(const GUID &Target, const GUID &Who, const AnsiString Description);
	virtual void __fastcall DoDisconnected(const int Reason, const AnsiString Description);
	virtual void __fastcall DoGetCompleted(const int Error, const Classes::TStream* Stream);
	virtual void __fastcall DoGetRequest(const AnsiString Name, const AnsiString Mime, /* out */ TwclObexServerOperationResult &Result, /* out */ Classes::TStream* &Stream);
	virtual void __fastcall DoProgress(const unsigned Length, const unsigned Position);
	virtual void __fastcall DoPutBegin(const AnsiString Name, const AnsiString Description, const AnsiString Mime, const unsigned Length, /* out */ bool &Accept);
	virtual void __fastcall DoPutCompleted(const int Error, const Classes::TStream* Stream, /* out */ bool &Accept);
	virtual void __fastcall DoPutProgress(const unsigned Position, const unsigned Length, /* out */ bool &Continue);
	__property GUID Who = {read=FWho};
	
public:
	__fastcall virtual TwclCustomObexServer(const Wclconnections::TwclServerClientDataConnection* Connection);
	__fastcall virtual ~TwclCustomObexServer(void);
	virtual void __fastcall ProcessData(const void * Data, const unsigned Size);
	int __fastcall Accept(const AnsiString Description, const Word PacketSize = (Word)(0xffff));
	int __fastcall Reject(const AnsiString Description);
	__property bool Connected = {read=GetConnected, nodefault};
	__property unsigned ConnectionId = {read=FConnectionId, nodefault};
	__property AnsiString Description = {read=FDescription};
	__property GUID Target = {read=FTarget};
	__property TwclObexServerClientDisconnectedEvent OnDisconnected = {read=FOnDisconnected, write=FOnDisconnected};
	__property TwclObexServerClientGetCompletedEvent OnGetCompleted = {read=FOnGetCompleted, write=FOnGetCompleted};
	__property TwclObexOperationProgressEvent OnProgress = {read=FOnProgress, write=FOnProgress};
	__property TwclObexServerClientPutBeginEvent OnPutBegin = {read=FOnPutBegin, write=FOnPutBegin};
	__property TwclObexServerClientPutCompletedEvent OnPutCompleted = {read=FOnPutCompleted, write=FOnPutCompleted};
	__property TwclObexServerClientOperationProgressEvent OnPutProgress = {read=FOnPutProgress, write=FOnPutProgress};
};


typedef void __fastcall (__closure *TwclObexOppServerConnectEvent)(System::TObject* Sender, const AnsiString Description);

typedef void __fastcall (__closure *TwclObexOppServerGetRequestEvent)(System::TObject* Sender, const AnsiString aType, /* out */ TwclObexServerOperationResult &Result, /* out */ Classes::TStream* &Stream);

class DELPHICLASS TwclObexOppServer;
class PASCALIMPLEMENTATION TwclObexOppServer : public TwclCustomObexServer 
{
	typedef TwclCustomObexServer inherited;
	
private:
	TwclObexOppServerConnectEvent FOnConnect;
	TwclObexOppServerGetRequestEvent FOnGetRequest;
	
protected:
	virtual void __fastcall DoConnect(const GUID &Target, const GUID &Who, const AnsiString Description);
	virtual void __fastcall DoGetRequest(const AnsiString Name, const AnsiString Mime, /* out */ TwclObexServerOperationResult &Result, /* out */ Classes::TStream* &Stream);
	
public:
	__fastcall virtual TwclObexOppServer(const Wclconnections::TwclServerClientDataConnection* Connection);
	__property TwclObexOppServerConnectEvent OnConnect = {read=FOnConnect, write=FOnConnect};
	__property TwclObexOppServerGetRequestEvent OnGetRequest = {read=FOnGetRequest, write=FOnGetRequest};
public:
	#pragma option push -w-inl
	/* TwclCustomObexServer.Destroy */ inline __fastcall virtual ~TwclObexOppServer(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Wclobex */
using namespace Wclobex;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Wclobex
