// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'wclIrDADevices.pas' rev: 6.00

#ifndef wclIrDADevicesHPP
#define wclIrDADevicesHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <wclWinAPI.hpp>	// Pascal unit
#include <WinSock.hpp>	// Pascal unit
#include <wclErrors.hpp>	// Pascal unit
#include <wclMessaging.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Wclirdadevices
{
//-- type declarations -------------------------------------------------------
#pragma option push -b
enum TwclIrDAConnectionMode { cmIrComm3Wire, cmIrComm9Wire, cmIrLpt };
#pragma option pop

#pragma option push -b
enum TwclIrDACharSet { csAscii, csIso8859_1, csIso8859_2, csIso8859_3, csIso8859_4, csIso8859_5, csIso8859_6, csIso8859_7, csIso8859_8, csIso8859_9, csUnicode };
#pragma option pop

#pragma option push -b
enum TwclIrDAHint { ihPnp, ihPda, ihComputer, ihPrinter, ihModem, ihFax, ihLan, ihTelephony, ihFileServer, ihComm, ihMessage, ihHttp, ihObex };
#pragma option pop

typedef Set<TwclIrDAHint, ihPnp, ihObex>  TwclIrDAHints;

#pragma pack(push, 4)
struct TwclIrDADevice
{
	unsigned Address;
	AnsiString Name;
	TwclIrDAHints Hints;
	TwclIrDACharSet CharSet;
} ;
#pragma pack(pop)

typedef DynamicArray<TwclIrDADevice >  TwclIrDADevices;

#pragma option push -b
enum TwclIrDAAttributeType { atInteger, atSequence, atString };
#pragma option pop

typedef DynamicArray<Byte >  wclIrDADevices__1;

#pragma pack(push, 4)
struct TwclIrDAAttribute
{
	TwclIrDAAttributeType ValueType;
	int IntegerValue;
	DynamicArray<Byte >  SequenceValue;
	AnsiString StringValue;
	TwclIrDACharSet CharSet;
} ;
#pragma pack(pop)

typedef void __fastcall (__closure *TwclIrDADevicesFoundEvent)(System::TObject* Sender, const TwclIrDADevice &Device);

class DELPHICLASS TwclIrDAReceiver;
class PASCALIMPLEMENTATION TwclIrDAReceiver : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FAvailable;
	_RTL_CRITICAL_SECTION FCS;
	int FError;
	unsigned FInitEvent;
	unsigned FTerminateEvent;
	Wclmessaging::TwclMessageReceiver* FReceiver;
	bool FSubscribed;
	unsigned FThread;
	Classes::TNotifyEvent FOnChange;
	TwclIrDADevicesFoundEvent FOnDevicesFound;
	bool __fastcall GetAvailable(void);
	bool __fastcall GetDiscovering(void);
	void __fastcall LazyDiscoveringThreadProc(void);
	
protected:
	virtual void __fastcall MessageReceived(const Wclmessaging::TwclMessage* Message);
	virtual void __fastcall DoChange(void);
	virtual void __fastcall DoDevicesFound(const TwclIrDADevice &Device);
	
public:
	__fastcall virtual TwclIrDAReceiver(Classes::TComponent* AOwner);
	__fastcall virtual ~TwclIrDAReceiver(void);
	int __fastcall Discover(/* out */ TwclIrDADevices &Devices);
	int __fastcall StartLazyDiscovering(void);
	int __fastcall StopLazyDiscovering(void);
	int __fastcall QueryAttribute(const unsigned Address, const AnsiString ClassName, const AnsiString AttributeName, /* out */ TwclIrDAAttribute &Attribute);
	int __fastcall Subscribe(void);
	int __fastcall Unsubscribe(void);
	__property bool Available = {read=GetAvailable, nodefault};
	__property bool Discovering = {read=GetDiscovering, nodefault};
	__property bool Subscribed = {read=FSubscribed, nodefault};
	
__published:
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TwclIrDADevicesFoundEvent OnDevicesFound = {read=FOnDevicesFound, write=FOnDevicesFound};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Wclirdadevices */
using namespace Wclirdadevices;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// wclIrDADevices
